package core

import (
	"git.urbach.dev/cli/q/src/eval"
	"git.urbach.dev/cli/q/src/expression"
)

// EvaluateCall evaluates a function call.
func (f *Function) EvaluateCall(expr *expression.Expression) (eval.Register, error) {
	typ, err := f.CompileCall(expr)

	if err != nil {
		return eval.Register{}, err
	}

	value := eval.Register{Register: f.CPU.Output[0]}

	if len(typ) > 0 {
		value.Typ = typ[0]
	}

	return value, nil
}
